<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$cg = \UnicaenCode\Util::codeGenerator();

$cg->start('Génération du PhpRenderer de l\'application');

$fullClassName = 'Application\View\Renderer\PhpRenderer';

?>
    <div class="alert alert-warning">
        <span class="glyphicon glyphicon glyphicon-thumbs-up"
              style="float: left;font-size:50pt;margin-right:.2em;margin-bottom:.2em"></span>
        Le PhpRenderer permet de bénéficier de l'auto-complétion des view helpers depuis vos vues.
        Pour l'utiliser, il convient de déclarer la ligne suivante au début de chaque vue :

        <?php phpDump('/* @var $this \\' . $fullClassName . ' */'); ?>

    </div>
<?php


$form = new \UnicaenCode\Form\CustomForm();

if (empty($params = $cg->formPublish($form))) return;

$vhs = Util::introspection()->getViewHelpers();

$methods = [];
foreach ($vhs as $key => $class) {
    $rc = new \ReflectionClass($class);
    if ($rc->hasMethod('__invoke')) {
        $method    = $rc->getMethod('__invoke');
        $methods[] = ' * ' . Util::getMethodDocDeclaration($rc->getMethod('__invoke'), $key, '\\' . $class);
    } else {
        $methods[] = " * @method \\$class $key()";
    }
}

$params['template'] = 'ApplicationPhpRenderer';
$params['filename'] = Util::classFilename($fullClassName);
$params['methods']  = implode("\n", $methods);

$cg->end($params);