<?php

use UnicaenCode\Form\AbstractForm;
use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$cg = \UnicaenCode\Util::codeGenerator();

$cg->start('Génération d\'une TemplateMap pour optimiser le traitement des vues');

$form = new \UnicaenCode\Form\CustomForm();

$form->addSelectModule(
    'module', 'Module concerné'
);


if (empty($params = $cg->formPublish($form))) return;

$moduleName = $form->get('module')->getValue();
$module     = Util::introspection()->getModule($moduleName);


$params['template'] = 'template_map';
$params['filename'] = 'module/' . $module['relPath'] . '/template_map.php';


$map = Util::introspection()->getViews($module['name']);

$mc = 0;
foreach ($map as $f) {
    $lc = strlen($f);
    if ($lc > $mc) $mc = $lc;
}
$php = '';
foreach ($map as $f) {
    $c   = $f;
    $php .= "    " . str_pad("'$c'", $mc + 2, ' ') . " => __DIR__ . '/" . $module['viewDir'] . "/$f.phtml',\n";
}

$params['map'] = trim($php);

$cg->end($params);