<?php

namespace UnicaenCode\Form;

class Form extends AbstractForm
{
    public function init()
    {
        $this->addSelect(
            'type', 'Type de formulaire (Form ou Fieldset)', ['Form' => 'Form', 'Fieldset' => 'Fieldset'], 'Form'
        );

        $this->addText(
            'class', 'Nom de classe du formulaire', 'Application\Form\MonFormulaireForm'
        );

        $this->addCheckbox(
            'useHydrator', 'Implémenter un hydrateur spécifique'
        );

        $this->addCheckbox(
            'awareTrait', 'Générer un trait', true
        );

        $this->addCheckbox(
            'awareInterface', 'Générer une interface', false
        );

        $this->addCheckbox(
            'useGetter', 'Générer des getters dans les traits et les interfaces', true
        );

        $this->addCheckbox(
            'factory', 'Générer une factory', true
        );

        $this->addCheckbox(
            'subDir', 'Les traits, interfaces et Factory seront placés dans des sous-dossiers dédiés', false
        );
    }



    public function getParams(): array
    {
        $type  = $this->get('type')->getValue();
        $class = $this->get('class')->getValue();

        $params = [
            'generator'   => 'Form',
            'type'        => $type,
            'class'       => $class,
            'useHydrator' => $this->get('useHydrator')->getValue(),
            'useGetter'   => $this->get('useGetter')->getValue(),
            'subDir'      => $this->get('subDir')->getValue(),
        ];
        if ($this->get('awareTrait')->getValue()) {
            $params['awareTrait'] = [];
        }
        if ($this->get('awareInterface')->getValue()) {
            $params['awareInterface'] = [];
        }
        if ($this->get('factory')->getValue()) {
            $params['factory'] = [];
        }

        return $params;
    }
}